<template>
  <div>
    <el-breadcrumb separator=">">
      <el-breadcrumb-item :to="{ path: '/' }">首页</el-breadcrumb-item>
      <el-breadcrumb-item>
        <a href="#">系统管理</a>
      </el-breadcrumb-item>
      <el-breadcrumb-item>
        <a href="/sys/role/list">角色管理</a>
      </el-breadcrumb-item>
    </el-breadcrumb>
    <el-divider></el-divider>
    <!--
      要resetFields起作用，必须配置:model和prop
    -->
    <el-form ref="queryForm" :model="queryModel" inline class="demo-form-inline">
      <el-form-item label="角色名称" prop="name">
        <el-input type="text" size="mini" v-model="queryModel.name"></el-input>
      </el-form-item>
      <el-form-item label="角色描述" prop="description">
        <el-input type="text" size="mini" v-model="queryModel.description"></el-input>
      </el-form-item>
      <el-form-item>
        <el-button
          type="primary"
          size="mini"
          icon="ios-search"
          @click="changePage(1)"
          :loading="loading"
        >查询</el-button>&nbsp;
        <el-button
          type="info"
          size="mini"
          style="margin-left: 8px"
          @click="handleReset('queryForm')"
        >重置</el-button>&nbsp;
      </el-form-item>
    </el-form>
    <el-divider></el-divider>
    <el-row class="button-group">
      <el-button type="primary" size="small" plain icon="el-icon-circle-plus" @click="handleAdd">新增</el-button>
      <el-button
        type="primary"
        size="small"
        plain
        icon="el-icon-remove"
        :disabled="multipleSelection.length==0"
        @click="handleBatchDelete"
      >删除选中项</el-button>
    </el-row>
    <el-table
      :data="tableData"
      style="min-height:400px;"
      v-loading="loading"
      stripe
      border
      @sort-change="sortChange"
      @selection-change="handleSelectionChange"
    >
      <el-table-column type="selection" width="55"></el-table-column>
      <el-table-column prop="name" sort-by="name_" label="角色名称" sortable="custom" width="180"></el-table-column>
      <el-table-column
        prop="description"
        sort-by="description_"
        label="角色描述"
        sortable="custom"
        width="180"
      ></el-table-column>
      <el-table-column
        prop="createTime"
        sort-by="create_time"
        label="创建时间"
        sortable="custom"
        width="180"
      ></el-table-column>
      <el-table-column
        prop="updateTime"
        sort-by="update_time"
        label="更新时间"
        sortable="custom"
        width="180"
      ></el-table-column>
      <el-table-column label="操作">
        <template slot-scope="{row}">
          <el-button size="mini" type="warn" @click="handleEdit(row)">编辑</el-button>
          <el-button size="mini" type="primary" @click="allocApiPerm(row)">分配接口</el-button>
          <el-button size="mini" type="primary" @click="allocMenu(row)">分配菜单</el-button>
          <el-button size="mini" type="danger" @click="handleDelete(row)">删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    <el-pagination
      :current-page.sync="pageIndex"
      :total="totalElements"
      :page-sizes="pageSizeList"
      @current-change="changePage"
      @size-change="pageSizeChange"
      layout="total, sizes, prev, pager, next, jumper"
    ></el-pagination>
    <!--角色信息-->
    <role-detail
      v-if="showDetailModal"
      :title="modalTitle"
      :roleId="roleId"
      @close="onDetailModalClose"
    ></role-detail>

    <!--分配菜单-->
    <role-menu
      v-if="showMenuModal"
      @close="onMenuModalClose"
      :roleId="roleId"
    ></role-menu>

    <!--分配接口权限-->
    <role-permission
      v-if="showPermModal"
      @close="onPermModalClose"
      :roleId="roleId"
    ></role-permission>

  </div>
</template>
<script>
import Constant from "@/constant";
import RoleDetail from "./role-detail";
import RoleMenu from "./role-menu";
import RolePermission from "./role-permission";
import roleApi from "@/api/sys/role";
import NProgress from "nprogress"; // progress bar
import "nprogress/nprogress.css"; // progress bar style

export default {
  name: 'SysRoleList',
  data() {
    var self = this;

    return {
      queryModel: {
        name: "",
        description: ""
      },
      loading: false,
      tableData: [],
      pageIndex: 1,
      pageSize: 10,
      totalPages: 0,
      totalElements: 0,
      field: "",
      direction: "",
      pageSizeList: [10, 20, 30],
      multipleSelection: [],
      roleId: "",
      modalTitle: "",
      showDetailModal: false,
      showMenuModal: false,
      showPermModal: false
    };
  },
  methods: {
    changePage(pageIndex) {
      var self = this;
      self.loading = true;
      
      self.pageIndex = pageIndex;
      var formData = new FormData();

      formData.append("pageIndex", self.pageIndex);
      formData.append("pageSize", self.pageSize);

      formData.append("id", self.queryModel.id);

      formData.append("roleName", self.queryModel.name);
      formData.append("roleDesc", self.queryModel.description);

      if (this.field != null) {
        formData.append("field", this.field);
      }

      if (this.direction != null) {
        formData.append("direction", this.direction);
      }

      roleApi
        .pageList(formData)
        .then(function(response) {
          self.loading = false;

          var jsonData = response.data;

          if(jsonData.result){
            var pageInfo = jsonData.data;

            self.tableData = pageInfo.data;
            self.totalPages = pageInfo.totalPages;
            self.totalElements = pageInfo.recordsTotal;
          }
          else {
            self.$message({
                message: jsonData.message + "",
                type: "warning"
              });
          }
        })
        .catch(error => {
          self.loading = false;
        });
    },
    pageSizeChange(pageSize) {
      this.pageSize = pageSize;
    },
    sortChange(data) {
      this.field = data.column.field;
      this.direction = data.order;

      this.changePage(this.pageIndex);
    },
    handleSelectionChange(val) {
      this.multipleSelection = val;
    },
    handleReset(name) {
      this.$refs[name].resetFields();
    },
    handleAdd() {
      var self = this;
      self.modalTitle = "新增";
      self.roleId = "";
      self.showDetailModal = true;
    },
    handleEdit(record) {
      var self = this;

      self.modalTitle = "编辑";
      self.roleId = record.id;
      self.showDetailModal = true;
    },
    handleDelete(record) {
      var self = this;

      self
        .$confirm("是否确认删除" + record.description + "?", "提示", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
        .then(() => {
          roleApi.remove(record.id).then(function(response) {
            var jsonData = response.data;

            if (jsonData.result) {
              // var index = self.tableData.indexOf(record);
              // self.tableData.splice(index, 1);
              self.changePage(self.pageIndex);

              self.$message({
                type: "success",
                message: "删除成功!"
              });
            }
          });
        });
    },
    handleBatchDelete() {
      var self = this;

      var idList = this.multipleSelection.map(record => {
        return record.id;
      });

      this.$confirm("是否确认删除选中项？", "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      }).then(() => {
        roleApi.batchRemove(idList).then(function(response) {
          var jsonData = response.data;

          if (jsonData.result) {
            self.changePage(self.pageIndex);

            self.$message({
              type: "success",
              message: "删除成功!"
            });
          }
        });
      });
    },
    onDetailModalClose(refresh) {
      console.log("onDetailModalClose");

      this.showDetailModal = false;

      if(refresh) {
        this.changePage(this.pageIndex);
      }
    },
    onPermModalClose(refresh) {
      this.showPermModal = false;

      if(refresh) {
        this.changePage(this.pageIndex);
      }
    },
    onMenuModalClose(refresh) {
      this.showMenuModal = false;

      if(refresh) {
        this.changePage(this.pageIndex);
      }
    },
    allocApiPerm(row) {
      this.roleId = row.id;
      this.showPermModal = true;
    },
    allocMenu(row) {
      this.roleId = row.id;
      this.showMenuModal = true;
    }
  },
  mounted: function() {
    this.changePage(1);
  },
  components: {
    "role-detail": RoleDetail,
    "role-menu": RoleMenu,
    "role-permission": RolePermission
  }
};
</script>
<style lang="scss" scoped>
.el-breadcrumb {
  margin: 10px;
  line-height: 20px;
}

.el-divider {
  margin: 5px 0;
}

.demo-form-inline {
  margin-left: 10px;
  text-align: left;
}

.button-group {
  padding: 10px;
  text-align: left;
}
</style>